Program AON_FOR_ROCKWELL_VOICE_MODEM;

Uses AonVars, AdpcmDec, Terminal, Spectro, Parser, Ringing, AntiAon;

{$M 16384,0,500000}
Var
  f: file;

Label
  WorkAgain;      {  横᪮ ࠡ }

Function NameOfExeFile : string;
var ParStr0 : string;
    BackSlash : byte;
begin
  ParStr0:=ParamStr(0);
  Repeat
    BackSlash:=Pos('\',ParStr0);
    If BackSlash<>0 Then Delete(ParStr0,1,BackSlash);
  Until BackSlash=0;
  NameOfExeFile:=ParStr0;
end;

Function PathOfExeFile(exename: string) : string;
var ParStr0 : string;
    NameLen : integer;
begin
  ParStr0:=ParamStr(0);
  NameLen:=Length(exename);
  Delete(ParStr0,Length(ParStr0)-NameLen+1,NameLen);
  PathOfExeFile:=ParStr0;
end;



BEGIN

  PathToAon_Exe:=PathOfExeFile(NameOfExeFile);

WorkAgain:
  {  䠩 樠樨 }
  Parse_Config;
  { ᫨  ப  }
  If ParamCount=0 Then begin
    RecordADPCM(ADPCM_buf);
    DecodeADPCM(ReceiveBytes);

    If SaveStream=1 Then begin
      assign(f,PathToAon_Exe+'atsanswr.raw');
      rewrite(f,1);
      blockwrite(f,pcm_buf,Round(ReceiveBytes*3.06));
      close(f);
    end;
  end
  { ᫨  ப   }
  Else begin
    { 뤠 ࠢ  襭 }
    If ParamStr(1)='?' Then Begin
      WriteLn('AON & AntiAON by Dmitri Pobegailov v1.2 October 1998');
      WriteLn;
      WriteLn('Usage : aon.exe ?');
      WriteLn('        aon.exe');
      WriteLn('        aon.exe [raw file]');
      WriteLn('        aon.exe [raw file] /d[ebug]');
      WriteLn('        ---------------------------');
      WriteLn('        aon.exe /anti');

      Halt(0);
    End
    { ⨀ }
    Else If (ParamStr(1)='/anti') OR (ParamStr(1)='/ANTI') Then Begin
      Anti_Aon;

      Halt(0);
    End
    { 㧪   䠩, 㪠   ப }
    Else Begin
      assign(f,ParamStr(1));
      {$I-}
      reset(f,1);
      {$I+}
      If IOresult<>0 Then begin
        WriteLn('File ',ParamStr(1),' not found');
        Halt(0);
      end;
      blockread(f,pcm_buf,Round(ReceiveBytes*3.06));
      close(f);

      If (ParamStr(ParamCount)='/d') OR (ParamStr(ParamCount)='/D')
        Then DebugMode:=1;

    End;
  end;
  {     }
  pcm_fft_analiser(pcm_buf);
  {   }
  If (EmulateRinging=1) AND (ParamCount=0) Then EmuRinging;


  {   砫  믮 ᫮ [横 &  ] }
  If (Cycle=1) AND (WaitForRing=1) AND (ParamCount=0) Then Goto WorkAgain;

END.