
Function DualToneOffset(Var buff:array of byte): Word;


Function DualToneFinder: word;
var FrAver: word;        { । . ࣨ  ᯥ }
    FrSum: word;
    fri: word;
    f1,f2,f3,f4,f5,f6: word;
    mf1,mf2,mf3,mf4,mf5,mf6: word;
    mfx: word;

begin


  f1:= F_700 - F_Delta; mf1:=0;
  f2:= F_900 - F_Delta; mf2:=0;
  f3:=F_1100 - F_Delta; mf3:=0;
  f4:=F_1300 - F_Delta; mf4:=0;
  f5:=F_1500 - F_Delta; mf5:=0;
  f6:=F_1700 - F_Delta; mf6:=0;


  FrSum:=0;
  for fri:=0 to F_Delta*2-1 do begin

    FrSum:=FrSum + B[f1+fri+FrameZero].Re+
                   B[f2+fri+FrameZero].Re+
                   B[f3+fri+FrameZero].Re+
                   B[f4+fri+FrameZero].Re+
                   B[f5+fri+FrameZero].Re+
                   B[f6+fri+FrameZero].Re;

    if B[f1+fri+FrameZero].Re>mf1 Then mf1:=B[f1+fri+FrameZero].Re;
    if B[f2+fri+FrameZero].Re>mf2 Then mf2:=B[f2+fri+FrameZero].Re;
    if B[f3+fri+FrameZero].Re>mf3 Then mf3:=B[f3+fri+FrameZero].Re;
    if B[f4+fri+FrameZero].Re>mf4 Then mf4:=B[f4+fri+FrameZero].Re;
    if B[f5+fri+FrameZero].Re>mf5 Then mf5:=B[f5+fri+FrameZero].Re;
    if B[f6+fri+FrameZero].Re>mf6 Then mf6:=B[f6+fri+FrameZero].Re;

  end;

  FrAver:=Round(FrSum/(F_Delta*12));
  {
  FrAver:=Round((mf1+mf2+mf3+mf4+mf5+mf6)/6);
  }

  mfx:=0;
  If mf1>FrAver Then Inc(mfx);
  If mf2>FrAver Then Inc(mfx);
  If mf3>FrAver Then Inc(mfx);
  If mf4>FrAver Then Inc(mfx);
  If mf5>FrAver Then Inc(mfx);
  If mf6>FrAver Then Inc(mfx);
  DualToneFinder:=mfx;

end;


var
  DualToneOffs: word;
  PeakCount: word;

Begin

  DualToneOffs:=0;

  Repeat

    {  ᨢ PCMframe }
    for vi:=ZeroOfs+DualToneOffs to ZeroOfs+DualToneOffs+FrameSize do
      B[vi-DualToneOffs].Re:=buff[vi-ZeroOfs]-128;
    for vi:=FrameSize+1 to 2047 do B[vi].Re:=0;

    FFTEnergy(B);
    {  ⠡ }
    for I:=0 to N div 2-1 do begin
      B[I].Re:=Round(Sqrt(Word(B[I].Re)));
      if B[I].Re>127 then B[I].Re:=127;
      if B[I].Re<2 then B[I].Re:=0;
    end;

    PeakCount:=DualToneFinder;
    If PeakCount>2 Then Inc(DualToneOffs,DTFinderStep);
                                        {===}

  Until (PeakCount=2) Or (DualToneOffs>DTFinderSamples);

  If DualToneOffs>600 Then DualToneOffset:=0
    Else DualToneOffset:=DualToneOffs;


End.
