Program Dual_Tone_Finder;

Uses FFT_Unit, Graph, Crt;


VAR
  { ६  FFT_UNIT }
  B,C:TComplexArray;
  I,J,K:Integer;

  FrameZero: word;
  FrameSize: word;

  F_700,F_900,F_1100,F_1300,F_1500,F_1700,F_Delta: word;

  f: file;
  buff: array[0..7000] of byte;

  vi: integer;

  abcd: word;



Function DualToneFinder: word;
var FrAver: word;        { । . ࣨ  ᯥ }
    FrSum: word;
    fi: word;
    f1,f2,f3,f4,f5,f6: word;
    mf1,mf2,mf3,mf4,mf5,mf6: word;
    mfx: word;

begin


  f1:= F_700 - F_Delta; mf1:=0;
  f2:= F_900 - F_Delta; mf2:=0;
  f3:=F_1100 - F_Delta; mf3:=0;
  f4:=F_1300 - F_Delta; mf4:=0;
  f5:=F_1500 - F_Delta; mf5:=0;
  f6:=F_1700 - F_Delta; mf6:=0;


  FrSum:=0;
  for fi:=0 to F_Delta*2-1 do begin

    FrSum:=FrSum + B[f1+fi+FrameZero].Re+
                   B[f2+fi+FrameZero].Re+
                   B[f3+fi+FrameZero].Re+
                   B[f4+fi+FrameZero].Re+
                   B[f5+fi+FrameZero].Re+
                   B[f6+fi+FrameZero].Re;

    if B[f1+fi+FrameZero].Re>mf1 Then mf1:=B[f1+fi+FrameZero].Re;
    if B[f2+fi+FrameZero].Re>mf2 Then mf2:=B[f2+fi+FrameZero].Re;
    if B[f3+fi+FrameZero].Re>mf3 Then mf3:=B[f3+fi+FrameZero].Re;
    if B[f4+fi+FrameZero].Re>mf4 Then mf4:=B[f4+fi+FrameZero].Re;
    if B[f5+fi+FrameZero].Re>mf5 Then mf5:=B[f5+fi+FrameZero].Re;
    if B[f6+fi+FrameZero].Re>mf6 Then mf6:=B[f6+fi+FrameZero].Re;

  end;

  FrAver:=Round(FrSum/(F_Delta*12));
  {
  FrAver:=Round((mf1+mf2+mf3+mf4+mf5+mf6)/6);
  }

  mfx:=0;
  If mf1>=FrAver Then Inc(mfx);
  If mf2>=FrAver Then Inc(mfx);
  If mf3>=FrAver Then Inc(mfx);
  If mf4>=FrAver Then Inc(mfx);
  If mf5>=FrAver Then Inc(mfx);
  If mf6>=FrAver Then Inc(mfx);
  DualToneFinder:=mfx;

  GotoXY(1,1);
  WriteLn(fraver,'   ',mf1,' ',mf2,' ',mf3,' ',mf4,' ',mf5,' ',mf6,'        ');

end;


var
  DualToneOffs: word;
  GrDrv,GrMode: integer;

  KeyPr: char;

  CurrentFrame: word;

Begin

  DirectVideo:=False;
  GrDrv:=Detect;
  InitGraph(GrDrv,GrMode,'d:\pascal\bgi');


  F_700:=80;
  F_900:=118;
  F_1100:=154;
  F_1300:=192;
  F_1500:=230;
  F_1700:=267;
  F_Delta:=6;

    FrameZero:=50;
    FrameSize:=440;

    Assign(f,'228468.raw');
    Reset(f,1);
    BlockRead(f,buff,6100);
    Close(f);

    DualToneOffs:=0;

    {
    CurrentFrame
    }

  Repeat

    {  ᨢ PCMframe }
    for vi:=DualToneOffs to DualToneOffs+FrameSize do
      B[vi-DualToneOffs].Re:=buff[vi]-128;
    for vi:=FrameSize+1 to 2047 do B[vi].Re:=0;


    SetColor(12);
    For vi:=0 to 639 do begin
      line(vi,200-B[vi].Re,vi,200);
    end;



    FFTEnergy(B);
    {  ⠡ }
    for I:=0 to N div 2-1 do begin
      B[I].Re:=Round(Sqrt(Word(B[I].Re)));
      if B[I].Re>127 then B[I].Re:=127;
      if B[I].Re<2 then B[I].Re:=0;
    end;


    SetColor(11);
    For vi:=0 to 639 do begin
      line(vi,450-B[vi].Re,vi,450);
    end;



    abcd:=DualToneFinder;
    If (abcd>2) OR (abcd<2) Then Inc(DualToneOffs,10);
           {===}


    gotoxy(1,2);
    writeln(abcd,'  ',dualtoneoffs,'   ');

    keypr:=readkey;


    SetColor(0);
    For vi:=0 to 639 do begin
      line(vi,450-B[vi].Re,vi,450);
    end;

    SetFillStyle(0,0);
    Bar(0,50,639,350);



  Until (abcd=2) Or (DualToneOffs>600) or (ord(keypr)=27);

  CloseGraph;
  WriteLn(DualToneOffs);

End.
