Unit PARSER;


INTERFACE

Uses AonVars, Terminal;

Procedure Parse_Config;

IMPLEMENTATION

Var
  CfgFile: text;

Function _UpCase(is: string): string;
var
  i : Integer;
begin
  for i := 1 to Length(is) do is[i] := UpCase(is[i]);
  _UpCase:=is;
end;


Procedure Parse_Config;
Var
  {  ப  cfg }
  CfgStr: String;
  { ࠬ, 祭 }
  CfgVar,VarVal: String;
  Vcode: Integer;
begin
  { ஢ઠ  稥 .cfg }
  {$I-}
  Assign(CfgFile,PathToAon_Exe+'aon.ini');
  Reset(CfgFile);
  {$I+}
  { ᫨  䠩 .cfg }
  If IoResult=0 Then Begin

    While Not(Eof(CfgFile)) Do Begin
      ReadLn(CfgFile,CfgStr);
      { 㥬 ப }
      { ᫨  ,  .  ஡  _;_    _=_ }
      {  ᫨  AT  __at }
      If (Copy(CfgStr,1,1)<>';') AND (Copy(CfgStr,1,1)<>' ')
         AND (CfgStr<>'') AND (Pos('=',CfgStr)<>0)
         AND (Copy(CfgStr,1,2)<>'__') Then Begin

           CfgVar:=Copy(CfgStr,1,Pos('=',CfgStr)-1);
           VarVal:=
           Copy(CfgStr,Pos('=',CfgStr)+1,Length(CfgStr)-Pos('=',CfgStr));

           { ᢮ 祭 ⥬ ६ }
           { ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ }
           CfgVar:=_UpCase(CfgVar); VarVal:=_UpCase(VarVal);
           { 㠫 }
           If CfgVar='FFT_GRAPH_MONITOR' Then
             VAL(VarVal,FFT_Graph_Monitor,Vcode);
           If CfgVar='DEBUGMODE'     Then VAL(VarVal,DebugMode,Vcode);
           { ஢ }
           If CfgVar='FRAMESIZE'     Then VAL(VarVal,FrameSize,Vcode);
           If CfgVar='FRAMEZERO'     Then VAL(VarVal,FrameZero,Vcode);
           If CfgVar='DECODEFRAMES'  Then VAL(VarVal,DecodeFrames,Vcode);

           If CfgVar='SEARCHFORPACKETOFFSET' Then
             VAL(VarVal,SearchForPacketOffset,Vcode);
           If CfgVar='VOLUMECORRECTION' Then
             VAL(VarVal,VolumeCorrection,Vcode);

           If CfgVar='DTFINDERSAMPLES'  Then VAL(VarVal,DTFinderSamples,Vcode);
           If CfgVar='DTFINDERSTEP'  Then VAL(VarVal,DTFinderStep,Vcode);


           If CfgVar='F_700'         Then VAL(VarVal,F_700,Vcode);
           If CfgVar='F_900'         Then VAL(VarVal,F_900,Vcode);
           If CfgVar='F_1100'        Then VAL(VarVal,F_1100,Vcode);
           If CfgVar='F_1300'        Then VAL(VarVal,F_1300,Vcode);
           If CfgVar='F_1500'        Then VAL(VarVal,F_1500,Vcode);
           If CfgVar='F_1700'        Then VAL(VarVal,F_1700,Vcode);
           If CfgVar='F_DELTA'       Then VAL(VarVal,F_Delta,Vcode);

           If CfgVar='STOPONFIRST13' Then VAL(VarVal,StopOnFirst13,Vcode);

           { ୠ }
           If CfgVar='LOGFILE'       Then LogFile:=VarVal;
           { ନ }
           If CfgVar='USEFOSSIL'     Then VAL(VarVal,UseFossil,Vcode);
           If CfgVar='MODEMPORT'     Then VAL(VarVal,ModemPort,Vcode);
           If CfgVar='MPORTIRQ'      Then VAL(VarVal,MPortIRQ,Vcode);
           If CfgVar='MPORTADDR'     Then VAL('$'+VarVal,MPortAddr,Vcode);
           If CfgVar='MPORTDATABITS' Then VAL(VarVal,MPortDataBits,Vcode);
           If CfgVar='MPORTSTOPBITS' Then VAL(VarVal,MPortStopBits,Vcode);
           If CfgVar='MPORTPARITY'   Then MPortParity:=VarVal[1];
           If CfgVar='PORTSPEED'     Then VAL(VarVal,PortSpeed,Vcode);

           If CfgVar='WAITFORMODEM'  Then VAL(VarVal,WaitForModem,Vcode);
           If CfgVar='TERMINALECHO'  Then VAL(VarVal,TerminalEcho,Vcode);
           If CfgVar='RECEIVEBYTES'  Then VAL(VarVal,ReceiveBytes,Vcode);
           If CfgVar='SAVESTREAM'    Then VAL(VarVal,SaveStream,Vcode);
           If CfgVar='WAITFORRING'   Then VAL(VarVal,WaitForRing,Vcode);
           If CfgVar='MODEMRINGING'  Then ModemRinging:=VarVal;
           If CfgVar='AUTOONHOOK'    Then VAL(VarVal,AutoOnHook,Vcode);
           If CfgVar='CYCLE'         Then VAL(VarVal,Cycle,Vcode);
           If CfgVar='EMULATERINGING'  Then VAL(VarVal,EmulateRinging,Vcode);
           If CfgVar='OFFHOOKTIME'   Then VAL(VarVal,OffHookTime,Vcode);

           If CfgVar='BLASTERSETS'   Then BlasterSets:=VarVal;
           If CfgVar='WAVEFILE'      Then WaveFile:=VarVal;
           If CfgVar='SB_RINGING'    Then VAL(VarVal,SB_Ringing,Vcode);

      End
      { AT  }
      Else If (Copy(CfgStr,1,2)='__') Then Begin
        Script_buf[Script_cnt,0]:=
       _UpCase(Copy(CfgStr,3,Pos('?',CfgStr)-3));

        Script_buf[Script_cnt,1]:=
       _UpCase(Copy(CfgStr,Pos('?',CfgStr)+1,Length(CfgStr)-Pos('?',CfgStr)));

       Inc(Script_cnt);
      End;
    End;
  End
  Else Begin
    { 䨣樮 䠩  }
    Halt(0);

  End;


  Close(CfgFile);

end;

BEGIN

END.
