Unit Terminal;

INTERFACE

Uses AonVars, Crt, {EtAsync} CommWrap;

VAR
  {   ਯ  20 ப (,⢥) }
  Script_buf: array[0..20,0..1] of string[60];
  { ⢮ ப  ਯ }
  Script_cnt: word;




Procedure RecordADPCM(Var tADPCM_buf: array of byte);
Procedure WaitRing;
{
Procedure AT_Cmd(cmd,ans0: string);
}


IMPLEMENTATION

VAR

  ChOUT,ChIN: Char;
  BytesRecd: word;
  DosTicker: longint absolute $0040:$006C;
  OldTick: longint;
  _atcmd: word;


Procedure RingSound;

Procedure _Sound(f,d: word);
begin
  Sound(f);
  Delay(d);
  NoSound;
end;

var c: word;

begin
  for c:=1 to 4 do begin
    _Sound(500,200);
    delay(150);
    _Sound(700,200);
    delay(150);
  end;
end;


Procedure WaitRing;
Var answ: string;
    _prkey: byte;
begin
  If TerminalEcho=1 Then
    WriteLn('Waiting for ring ...       ESC-Exit     Other Key-Process');
  answ:='';
  OldTick:=DosTicker;
  Repeat
    repeat
    until (_CheckCOM(ModemPort,ChIn)) OR (KeyPressed);
    If Not KeyPressed Then Begin
      If TerminalEcho=1 Then Write(ChIn);
      If (ChIn<>Chr(10)) AND (ChIn<>Chr(13)) then answ:=answ+ChIn;
    End;
  Until (POS(ModemRinging,answ)<>0) OR (KeyPressed);

  If KeyPressed Then _prkey:=Ord(ReadKey);
  If _prkey=27 Then begin
    _CloseCOM(ModemPort);
    Halt(0);
  end;
  RingSound;

end;

(*
Procedure AT_Cmd(cmd,ans0: string);
var answ: string;
begin
  WriteCOMString(ModemPort,cmd+#13#10);
  answ:='';
  OldTick:=DosTicker;
  Repeat
    repeat
      if DosTicker-OldTick>WaitForModem*18 then begin
         CloseCOM(ModemPort);
         If TerminalEcho=1 Then
           WriteLn('Modem not responding !');
         Halt(0);
      end;
    until CheckCOM(ModemPort,ChIn);
    If TerminalEcho=1 Then Write(ChIn);
    If (ChIn<>Chr(10)) AND (ChIn<>Chr(13)) then answ:=answ+ChIn;

    If pos('ERROR',answ)<>0 then begin
       CloseCOM(ModemPort);
       Halt(0);
    end;

  Until (ChIn=Chr(10)) AND
  (copy(answ,length(answ)-(length(ans0)-1),length(ans0))=ans0);
end;
*)

Procedure RecordADPCM(Var tADPCM_buf: array of byte);

begin
  _OpenCOM(ModemPort,
          MPortAddr,
          MPortIRQ,
          PortSpeed,
          MPortParity,
          MPortDataBits,
          MPortStopBits,
          8192,True);

  _ResetCOM(ModemPort);


  BytesRecd:=0;
  {
  AT_Cmd('atz','OK');
  AT_Cmd('at#cls=8','OK');
  AT_Cmd('at#vbs=4','OK');
  AT_Cmd('at#vsr=7200','OK');
  AT_Cmd('ata','VCON');
  AT_Cmd('at#vts=[500,500,1]','OK');
  AT_Cmd('at#vrx','CONNECT');
  }
  If WaitForRing=1 Then WaitRing;

  for _atcmd:=0 to Script_cnt-1 do begin
    AT_Cmd(Script_buf[_atcmd,0], Script_buf[_atcmd,1]);
  end;

  Repeat
    If _CheckCOM(ModemPort,ChIn) then begin
      tADPCM_buf[BytesRecd]:=Ord(ChIn);
      Inc(BytesRecd);
    end;
  Until BytesRecd=ReceiveBytes;
  {
  TerminalEcho:=1;
  }
  AT_Cmd(#27,'VCON');
  {AT_Cmd('+++','VCON');}

  If (AutoOnHook=1) AND (EmulateRinging=0) Then AT_Cmd('ath','OK');

  If EmulateRinging=0 Then _CloseCOM(ModemPort);
end;

BEGIN
  Script_cnt:=0;

END.
