Unit ADPCMDEC;

INTERFACE

TYPE   PCMBUF = array[0..12000] of integer;
     {ADPCMBUF = array[0..4000] of byte;}

VAR

    ADPCM_buf: array[0..4000] of byte;
    {
    ADPCM_buf: ^ADPCMBUF;
    }

  PCM7200_buf: ^PCMBUF;
 PCM11025_buf: ^PCMBUF;
      PCM_buf: array[0..12000] of byte;

Procedure DecodeADPCM(bytes: word);


IMPLEMENTATION


VAR
        DEC_buf: array[0..20] of integer;
         sign8b: shortint;
   PtrIn,PtrOut: word;
 QDw0,QDw1,QDw2: word;

{$L dmasm.obj}

Procedure
   RVDecom4bps(qd0,qd1,qd2:word; ynptr: pointer); external;
Procedure
   RVInterpBuf_11025(_Spointer,_Dpointer: pointer; npoints: word); external;

Procedure DecodeADPCM(bytes: word);
begin
  PtrIn:=0; PtrOut:=0;
  New(PCM7200_buf);

  Repeat
    QDw0:=ADPCM_buf[PtrIn+0] +  256 * ADPCM_buf[PtrIn+1];
    QDw1:=ADPCM_buf[PtrIn+2] +  256 * ADPCM_buf[PtrIn+3];
    QDw2:=ADPCM_buf[PtrIn+4] +  256 * ADPCM_buf[PtrIn+5];

    RVDecom4bps(QDw0,QDw1,QDw2,PTR(SEG(DEC_buf),OFS(DEC_buf)));
    {
    PCM_buf[PtrOut+ 0]:=(DEC_buf[ 0] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 1]:=(DEC_buf[ 1] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 2]:=(DEC_buf[ 2] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 3]:=(DEC_buf[ 3] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 4]:=(DEC_buf[ 4] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 5]:=(DEC_buf[ 5] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 6]:=(DEC_buf[ 6] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 7]:=(DEC_buf[ 7] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 8]:=(DEC_buf[ 8] SHR 8) AND $00FF;
    PCM_buf[PtrOut+ 9]:=(DEC_buf[ 9] SHR 8) AND $00FF;
    PCM_buf[PtrOut+10]:=(DEC_buf[10] SHR 8) AND $00FF;
    PCM_buf[PtrOut+11]:=(DEC_buf[11] SHR 8) AND $00FF;
    }
    PCM7200_buf^[PtrOut+ 0]:=DEC_buf[ 0];
    PCM7200_buf^[PtrOut+ 1]:=DEC_buf[ 1];
    PCM7200_buf^[PtrOut+ 2]:=DEC_buf[ 2];
    PCM7200_buf^[PtrOut+ 3]:=DEC_buf[ 3];
    PCM7200_buf^[PtrOut+ 4]:=DEC_buf[ 4];
    PCM7200_buf^[PtrOut+ 5]:=DEC_buf[ 5];
    PCM7200_buf^[PtrOut+ 6]:=DEC_buf[ 6];
    PCM7200_buf^[PtrOut+ 7]:=DEC_buf[ 7];
    PCM7200_buf^[PtrOut+ 8]:=DEC_buf[ 8];
    PCM7200_buf^[PtrOut+ 9]:=DEC_buf[ 9];
    PCM7200_buf^[PtrOut+10]:=DEC_buf[10];
    PCM7200_buf^[PtrOut+11]:=DEC_buf[11];

    Inc(PtrOut,12);
    Inc(PtrIn,6);

  Until PtrIn > bytes;

  {  7200 -> 11025 }
  New(PCM11025_buf);
  RVInterpBuf_11025
    (PTR(SEG(PCM7200_buf^),OFS(PCM7200_buf^)),
     PTR(SEG(PCM11025_buf^),OFS(PCM11025_buf^)),
     bytes*2);

  {   8 bit   }

  For PtrOut:=0 to bytes*3 do begin
    PCM_buf[PtrOut]:=(PCM11025_buf^[PtrOut] SHR 8) AND $00FF;
    sign8b:=PCM_buf[PtrOut];
    PCM_buf[PtrOut]:=128+sign8b;
  end;

end;

BEGIN
  {
  New(ADPCM_buf);
  }
END.